# Contribution guidelines

## For Issues:

0. Check for **similar issues** first!
0. Provide as **many details** as possible

## For Pull Requests:

0. Indent using **2 spaces**
0. Use **double quotes** for strings
  * Exception: `'"'`
0. Write only **one expression per line**
  * Bad: `foo(); bar();`
0. Write **valid JavaScript**, a code linter is recommended!
0. **Explain code** that is not obvious (comment above)
0. If you add new functions, **add documentation** (comment above)
  * Wrap function arguments in `+` signs (e.g. `the +type+ is used for…`)
0. If you add new functions, **add tests** (test/test.js)
0. If you fixed an issue, **add a test** that would catch this issue
0. Run **tests** (`npm test`)
0. Make sure as much of your code as possible is **covered by tests**
0. Double check that your pull request is **awesome** :)